<template>
  <div id="cascaderMap">
    <span class="buildFloor" style="margin-right: 12px;">设备类别</span>
    <el-select v-model="value" placeholder="请选择" clearable :props="props" filterable :style="isWidth ? '' : 'width:160px;'" size="small"
      @change="changeVal">
      <el-option v-for="item in options" :key="item.code" :label="item.facility" :value="item.code"></el-option>
    </el-select>
    <!-- <el-cascader placeholder="请选择" :options="options" v-model="value" :props="props" filterable :style="isWidth ? '' : 'width:160px;'" size="small"
      @change="changeVal" change-on-select></el-cascader> -->
  </div>
</template>
<script>
import { mapGetters } from 'vuex';
import { getEquipBelongs, queryEquip } from "@/api/scan/request";
export default {
  name: "getCode",
  props: {
    isWidth: {
      type: Boolean,
      default: true
    },
    all: {
      type: Boolean,
      default: false,
    }
  },
  computed: {
    ...mapGetters("layout", ["projectId"])
  },
  data() {
    return {
      value: "",
      options: [],
      props: {
        value: "code",
        label: "facility"
      },
      falg: true,
      content: []
    };
  },
  created() {
    this.getData();
  },
  watch: {
    projectId() {
      this.value = '';
      this.getData();
    }
  },
  methods: {
    setValue(val) {
      this.value = val
    },
    //修改val
    changeVal(val) {
      let value = {}
      let flag = true;
      this.options.map(item => {
        if (item.code == val) {
          flag = false;
          value = item
        }
      })
      this.value = val
      if (flag) {
        this.value = '';
      }
      console.log(value)
      this.$emit("change", value)
    },
    //获取当前项目下的设备类型(只拿到编码-需要过滤)
    getData() {
      let param2 = {
        Distinct: true,
        PageNumber: 1,
        PageSize: 500,
        Projection: [
          "Category"
        ]
      }
      let param1 = {
        data: {
          Distinct: true,
          Orders: "EquipName asc",
          PageNumber: 1,
          PageSize: 500,
          Projection: [
            "EquipCode", "EquipName"
          ]
        }
      }
      let promise2 = new Promise((resolve, reject) => {
        queryEquip(param2, res => {
          resolve(res)
        })
      })
      let promise1 = new Promise((resolve, reject) => {
        getEquipBelongs(param1, res => {
          resolve(res)
        })
      })
      Promise.all([promise1, promise2]).then((res) => {
        let allData = res[0], data = res[1]
        this.options = this.formatOptions(allData.Content)
        if (!this.all) {
          this.content = data.Content.map(t => {
            return t.Category
          });
          this.filterForOptions();
        }
        if (this.value) {
          this.changeVal(this.value)
        }
      })
    },
    //格式化options数据
    formatOptions(arr) {
      let data = [];
      arr.map(t => {
        let temp = {};
        temp.code = t.EquipCode;
        temp.facility = t.EquipName;
        data.push(temp)
      })
      return data;
    },
    //过滤
    filterForOptions() {
      this.options = this.options.filter(item => {
        if (this.content.indexOf(item.code) > -1) {
          return item
        }
      })
    }
  }
};
</script>
<style lang="less" scoped>
#cascaderMap {
  float: left;
  margin-left: 10px;
  .buildFloor {
    color: #999999;
    font-size: 14px;
  }
}
</style>
